#!/bin/sh

set -euo pipefail

# Define the paths to the SquashFS images
IMAGE="$1"

echo $IMAGE

# Define the mount points
MOUNTPOINT="./firmware"

# Create the mount points if they don't exist
mkdir -p $MOUNTPOINT

# Extract the files we need
7z x -o$MOUNTPOINT $IMAGE www/tool/ etc/*.crt -bsp1 -bso0 -bse0 -y

echo "Extracting certificate..."
cp $MOUNTPOINT/etc/*.crt ./apicert.crt

# Perform the diff and show only the differences
#diff --no-dereference -r $MOUNTPOINT
